<script>
    import Input from 'components/Authentication/Input.svelte'
    import Layout from 'components/Authentication/Layout.svelte'
    import validate from 'lib/validate'
    import { register } from 'lib/auth'

    let username
    let name
    let password
    let password_confirmation
    let usernameError
    let inputs = {}

    const submit = async () => {
        // Bail if validation does not pass
        if (!(await validate(inputs))) return

        const { errors } = await register(username, name, password)
        usernameError = errors.username
    }
</script>

<Layout on:click={submit}>
    <slot slot="title">Bienvenue</slot>
    <slot slot="subtitle">Faisons connaissance</slot>
    <Input
        type="text"
        placeholder="Foo Bar"
        name="name"
        rules={['required', 'between:1:30']}
        bind:value={name}
        bind:this={inputs.name}
    >Nom d'affichage</Input>
    <Input
        type="text"
        placeholder="foobar"
        name="username"
        rules={['required', 'unique', 'between:2:18', 'alpha_dash']}
        bind:value={username}
        bind:this={inputs.username}
        errors={usernameError}
    >Nom d'utilisateur</Input>
    <Input
        type="password"
        placeholder="********"
        name="password"
        rules={['required', 'min:8']}
        bind:value={password}
        bind:this={inputs.password}
    >Mot de passe</Input>
    <Input
        type="password"
        placeholder="********"
        name="password_confirmation"
        rules={[`confirmation:${password}`]}
        bind:value={password_confirmation}
        bind:this={inputs.password_confirmation}
    >Confirmation du mot de passe</Input>
    <slot slot="link">
        Tu as déjà un compte ?
        <a href="/connexion">Connecte-toi</a>
    </slot>
</Layout>
